diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index 8ca83be67ae5bf4c4eabc023253c342eac278d89..e91932720dd94d521592e5e78a4170742bcf8558 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -2936,21 +2998,25 @@ class security_domain:
                 raise
         return None
 
-# PKI Deployment 'systemd' Execution Management Class
-class systemd:
+class _Systemd:
+    """PKI Deployment 'systemd' Execution Management Class"""
+    
+    def __init__(self, pki_master_dict):
+        self.master_dict = pki_master_dict
+    
     def start(self, critical_failure = True):
         try:
             # Compose this "systemd" execution management command
-            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            if self.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "start" + " " + \
                           "pki-apached" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
-            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                          self.master_dict['pki_instance_name'] + "." + "service"
+            elif self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "start" + " " + \
                           "pki-tomcatd" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
+                          self.master_dict['pki_instance_name'] + "." + "service"
             # Display this "systemd" execution managment command
             config.pki_log.info(
                 log.PKIHELPER_SYSTEMD_COMMAND_1, command,
@@ -2967,16 +3033,16 @@ class systemd:
     def stop(self, critical_failure = True):
         try:
             # Compose this "systemd" execution management command
-            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            if self.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "stop" + " " + \
                           "pki-apached" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
-            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                          self.master_dict['pki_instance_name'] + "." + "service"
+            elif self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "stop" + " " + \
                           "pki-tomcatd" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
+                          self.master_dict['pki_instance_name'] + "." + "service"
             # Display this "systemd" execution managment command
             config.pki_log.info(
                 log.PKIHELPER_SYSTEMD_COMMAND_1, command,
@@ -2993,16 +3059,16 @@ class systemd:
     def restart(self, critical_failure = True):
         try:
             # Compose this "systemd" execution management command
-            if master['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
+            if self.master_dict['pki_subsystem'] in config.PKI_APACHE_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "restart" + " " + \
                           "pki-apached" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
-            elif master['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
+                          self.master_dict['pki_instance_name'] + "." + "service"
+            elif self.master_dict['pki_subsystem'] in config.PKI_TOMCAT_SUBSYSTEMS:
                 command = "systemctl" + " " + \
                           "restart" + " " + \
                           "pki-tomcatd" + "@" + \
-                          master['pki_instance_name'] + "." + "service"
+                          self.master_dict['pki_instance_name'] + "." + "service"
             # Display this "systemd" execution managment command
             config.pki_log.info(
                 log.PKIHELPER_SYSTEMD_COMMAND_1, command,
@@ -3017,7 +3083,12 @@ class systemd:
         return
 
 
-class config_client:
+class _ConfigClient:
+    """PKI Deployment Configuration Client"""
+    
+    def __init__(self, deployer):
+        self.deployer = deployer
+        self.master_dict = deployer.master_dict
 
     def configure_pki_data(self, data):
         config.pki_log.info(log.PKI_CONFIG_CONFIGURING_PKI_DATA,
@@ -3025,9 +3096,9 @@ class config_client:
 
         self.connection = pki.client.PKIConnection(
             protocol = 'https',
-            hostname = master['pki_hostname'],
-            port = master['pki_https_port'],
-            subsystem = master['pki_subsystem_type'])
+            hostname = self.master_dict['pki_hostname'],
+            port = self.master_dict['pki_https_port'],
+            subsystem = self.master_dict['pki_subsystem_type'])
 
         try:
             client = pki.system.SystemConfigClient(self.connection)
@@ -3040,9 +3111,9 @@ class config_client:
             if not isinstance(certs, types.ListType):
                 certs = [certs]
             for cdata in certs:
-                if master['pki_subsystem'] == "CA" and\
-                   config.str2bool(master['pki_external']) and\
-                   not config.str2bool(master['pki_external_step_two']):
+                if self.master_dict['pki_subsystem'] == "CA" and\
+                   config.str2bool(self.master_dict['pki_external']) and\
+                   not config.str2bool(self.master_dict['pki_external_step_two']):
                     # External CA Step 1
                     if cdata['tag'].lower() == "signing":
                         config.pki_log.info(log.PKI_CONFIG_CDATA_REQUEST + \
@@ -3051,11 +3122,11 @@ class config_client:
 
                         # Save 'External CA Signing Certificate' CSR (Step 1)
                         config.pki_log.info(log.PKI_CONFIG_EXTERNAL_CSR_SAVE + \
-                            " '" + master['pki_external_csr_path'] + "'",
+                            " '" + self.master_dict['pki_external_csr_path'] + "'",
                             extra = config.PKI_INDENTATION_LEVEL_2)
-                        directory.create(
-                            os.path.dirname(master['pki_external_csr_path']))
-                        with open(master['pki_external_csr_path'], "w") as f:
+                        self.deployer.directory.create(
+                            os.path.dirname(self.master_dict['pki_external_csr_path']))
+                        with open(self.master_dict['pki_external_csr_path'], "w") as f:
                             f.write(cdata['request'])
                         return
                 else:
@@ -3070,8 +3141,8 @@ class config_client:
                                          extra = config.PKI_INDENTATION_LEVEL_2)
 
             # Cloned PKI subsystems do not return an Admin Certificate
-            if not config.str2bool(master['pki_clone']) and \
-               not config.str2bool(master['pki_import_admin_cert']):
+            if not config.str2bool(self.master_dict['pki_clone']) and \
+               not config.str2bool(self.master_dict['pki_import_admin_cert']):
                 admin_cert = response['adminCert']['cert']
                 self.process_admin_cert(admin_cert)
 
@@ -3096,7 +3167,7 @@ class config_client:
                              extra = config.PKI_INDENTATION_LEVEL_2)
 
         # Store the Administration Certificate in a file
-        admin_cert_file = master['pki_client_admin_cert']
+        admin_cert_file = self.master_dict['pki_client_admin_cert']
         admin_cert_bin_file = admin_cert_file + ".der"
         config.pki_log.debug(log.PKI_CONFIG_ADMIN_CERT_SAVE + \
                                " '" + admin_cert_file + "'",
@@ -3118,29 +3189,29 @@ class config_client:
 
         # Import the Administration Certificate
         # into the client NSS security database
-        certutil.import_cert(
-            re.sub("&#39;", "'", master['pki_admin_nickname']),
+        self.deployer.certutil.import_cert(
+            re.sub("&#39;", "'", self.master_dict['pki_admin_nickname']),
             "u,u,u",
             admin_cert_bin_file,
-            master['pki_client_password_conf'],
-            master['pki_client_database_dir'],
+            self.master_dict['pki_client_password_conf'],
+            self.master_dict['pki_client_database_dir'],
             None,
             True)
 
         # create directory for p12 file if it does not exist
-        directory.create(os.path.dirname(
-            master['pki_client_admin_cert_p12']))
+        self.deployer.directory.create(os.path.dirname(
+            self.master_dict['pki_client_admin_cert_p12']))
 
         # Export the Administration Certificate from the
         # client NSS security database into a PKCS #12 file
-        pk12util.create_file(
-            master['pki_client_admin_cert_p12'],
-            re.sub("&#39;", "'", master['pki_admin_nickname']),
-            master['pki_client_pkcs12_password_conf'],
-            master['pki_client_password_conf'],
-            master['pki_client_database_dir'])
+        self.deployer.pk12util.create_file(
+            self.master_dict['pki_client_admin_cert_p12'],
+            re.sub("&#39;", "'", self.master_dict['pki_admin_nickname']),
+            self.master_dict['pki_client_pkcs12_password_conf'],
+            self.master_dict['pki_client_password_conf'],
+            self.master_dict['pki_client_database_dir'])
 
-        os.chmod(master['pki_client_admin_cert_p12'],
+        os.chmod(self.master_dict['pki_client_admin_cert_p12'],
             config.PKI_DEPLOYMENT_DEFAULT_SECURITY_DATABASE_PERMISSIONS)
 
 
@@ -3151,12 +3222,12 @@ class config_client:
         data = pki.system.ConfigurationRequest()
 
         # Miscellaneous Configuration Information
-        data.pin = master['pki_one_time_pin']
-        data.subsystemName = master['pki_subsystem_name']
+        data.pin = self.master_dict['pki_one_time_pin']
+        data.subsystemName = self.master_dict['pki_subsystem_name']
 
         # Cloning parameters
-        if master['pki_instance_type'] == "Tomcat":
-            if config.str2bool(master['pki_clone']):
+        if self.master_dict['pki_instance_type'] == "Tomcat":
+            if config.str2bool(self.master_dict['pki_clone']):
                 self.set_cloning_parameters(data)
             else:
                 data.isClone = "false"
@@ -3165,9 +3236,9 @@ class config_client:
         self.set_hierarchy_parameters(data)
 
         # Security Domain
-        if master['pki_subsystem'] != "CA" or\
-           config.str2bool(master['pki_clone']) or\
-           config.str2bool(master['pki_subordinate']):
+        if self.master_dict['pki_subsystem'] != "CA" or\
+           config.str2bool(self.master_dict['pki_clone']) or\
+           config.str2bool(self.master_dict['pki_subordinate']):
             # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
             # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone, or
             # Subordinate CA
@@ -3177,15 +3248,15 @@ class config_client:
             self.set_new_security_domain(data)
 
         # database
-        if master['pki_subsystem'] != "RA":
+        if self.master_dict['pki_subsystem'] != "RA":
             self.set_database_parameters(data)
 
         # backup
-        if master['pki_instance_type'] == "Tomcat":
+        if self.master_dict['pki_instance_type'] == "Tomcat":
             self.set_backup_parameters(data)
 
         # admin user
-        if not config.str2bool(master['pki_clone']):
+        if not config.str2bool(self.master_dict['pki_clone']):
             self.set_admin_parameters(data)
 
         # Issuing CA Information
@@ -3200,39 +3271,39 @@ class config_client:
         systemCerts = []
 
         # Create 'CA Signing Certificate'
-        if master['pki_subsystem'] == "CA":
-            if not config.str2bool(master['pki_clone']):
+        if self.master_dict['pki_subsystem'] == "CA":
+            if not config.str2bool(self.master_dict['pki_clone']):
                 cert1 = self.create_system_cert("ca_signing")
                 cert1.signingAlgorithm = \
-                    master['pki_ca_signing_signing_algorithm']
-                if config.str2bool(master['pki_external_step_two']):
+                    self.master_dict['pki_ca_signing_signing_algorithm']
+                if config.str2bool(self.master_dict['pki_external_step_two']):
                     # Load the 'External CA Signing Certificate' (Step 2)
                     print(
                         log.PKI_CONFIG_EXTERNAL_CA_LOAD + " " + \
-                        "'" + master['pki_external_ca_cert_path'] + "'")
-                    with open(master['pki_external_ca_cert_path']) as f:
+                        "'" + self.master_dict['pki_external_ca_cert_path'] + "'")
+                    with open(self.master_dict['pki_external_ca_cert_path']) as f:
                         external_cert = f.read()
                     cert1.cert = external_cert
 
                     # Load the 'External CA Signing Certificate Chain' (Step 2)
                     print(
                         log.PKI_CONFIG_EXTERNAL_CA_CHAIN_LOAD + " " + \
-                        "'" + master['pki_external_ca_cert_chain_path'] + \
+                        "'" + self.master_dict['pki_external_ca_cert_chain_path'] + \
                         "'")
-                    with open(master['pki_external_ca_cert_chain_path']) as f:
+                    with open(self.master_dict['pki_external_ca_cert_chain_path']) as f:
                         external_cert_chain = f.read()
 
                     cert1.certChain = external_cert_chain
                 systemCerts.append(cert1)
 
         # Create 'OCSP Signing Certificate'
-        if not config.str2bool(master['pki_clone']):
-            if master['pki_subsystem'] == "CA" or\
-               master['pki_subsystem'] == "OCSP":
+        if not config.str2bool(self.master_dict['pki_clone']):
+            if self.master_dict['pki_subsystem'] == "CA" or\
+               self.master_dict['pki_subsystem'] == "OCSP":
                 # External CA, Subordinate CA, PKI CA, or PKI OCSP
                 cert2 = self.create_system_cert("ocsp_signing")
                 cert2.signingAlgorithm = \
-                    master['pki_ocsp_signing_signing_algorithm']
+                    self.master_dict['pki_ocsp_signing_signing_algorithm']
                 systemCerts.append(cert2)
 
         # Create 'SSL Server Certificate'
@@ -3240,13 +3311,13 @@ class config_client:
 
         # create new sslserver cert only if this is a new instance
         cert3 = None
-        system_list = instance.tomcat_instance_subsystems()
+        system_list = self.deployer.instance.tomcat_instance_subsystems()
         if len(system_list) >= 2:
             data.generateServerCert = "false"
             for subsystem in system_list:
-                dst = master['pki_instance_path'] + '/conf/' + \
+                dst = self.master_dict['pki_instance_path'] + '/conf/' + \
                     subsystem.lower() + '/CS.cfg'
-                if subsystem != master['pki_subsystem'] and \
+                if subsystem != self.master_dict['pki_subsystem'] and \
                    os.path.exists(dst):
                     cert3 = self.retrieve_existing_server_cert(dst)
                     break
@@ -3255,21 +3326,21 @@ class config_client:
         systemCerts.append(cert3)
 
         # Create 'Subsystem Certificate'
-        if not config.str2bool(master['pki_clone']):
+        if not config.str2bool(self.master_dict['pki_clone']):
             cert4 = self.create_system_cert("subsystem")
             systemCerts.append(cert4)
 
         # Create 'Audit Signing Certificate'
-        if not config.str2bool(master['pki_clone']):
-            if master['pki_subsystem'] != "RA":
+        if not config.str2bool(self.master_dict['pki_clone']):
+            if self.master_dict['pki_subsystem'] != "RA":
                 cert5 = self.create_system_cert("audit_signing")
                 cert5.signingAlgorithm = \
-                    master['pki_audit_signing_signing_algorithm']
+                    self.master_dict['pki_audit_signing_signing_algorithm']
                 systemCerts.append(cert5)
 
         # Create DRM Transport and storage Certificates
-        if not config.str2bool(master['pki_clone']):
-            if master['pki_subsystem'] == "KRA":
+        if not config.str2bool(self.master_dict['pki_clone']):
+            if self.master_dict['pki_subsystem'] == "KRA":
                 cert6 = self.create_system_cert("transport")
                 systemCerts.append(cert6)
 
@@ -3280,28 +3351,28 @@ class config_client:
 
     def set_cloning_parameters(self, data):
         data.isClone = "true"
-        data.cloneUri = master['pki_clone_uri']
-        data.p12File = master['pki_clone_pkcs12_path']
-        data.p12Password = master['pki_clone_pkcs12_password']
-        data.replicateSchema = master['pki_clone_replicate_schema']
+        data.cloneUri = self.master_dict['pki_clone_uri']
+        data.p12File = self.master_dict['pki_clone_pkcs12_path']
+        data.p12Password = self.master_dict['pki_clone_pkcs12_password']
+        data.replicateSchema = self.master_dict['pki_clone_replicate_schema']
         data.replicationSecurity = \
-            master['pki_clone_replication_security']
-        if master['pki_clone_replication_master_port']:
+            self.master_dict['pki_clone_replication_security']
+        if self.master_dict['pki_clone_replication_master_port']:
             data.masterReplicationPort = \
-                master['pki_clone_replication_master_port']
-        if master['pki_clone_replication_clone_port']:
+                self.master_dict['pki_clone_replication_master_port']
+        if self.master_dict['pki_clone_replication_clone_port']:
             data.cloneReplicationPort = \
-                master['pki_clone_replication_clone_port']
+                self.master_dict['pki_clone_replication_clone_port']
 
     def set_hierarchy_parameters(self, data):
-        if master['pki_subsystem'] == "CA":
-            if config.str2bool(master['pki_clone']):
+        if self.master_dict['pki_subsystem'] == "CA":
+            if config.str2bool(self.master_dict['pki_clone']):
                 # Cloned CA
                 data.hierarchy = "root"
-            elif config.str2bool(master['pki_external']):
+            elif config.str2bool(self.master_dict['pki_external']):
                 # External CA
                 data.hierarchy = "join"
-            elif config.str2bool(master['pki_subordinate']):
+            elif config.str2bool(self.master_dict['pki_subordinate']):
                 # Subordinate CA
                 data.hierarchy = "join"
             else:
@@ -3310,73 +3381,73 @@ class config_client:
 
     def set_existing_security_domain(self, data):
         data.securityDomainType = "existingdomain"
-        data.securityDomainUri = master['pki_security_domain_uri']
-        data.securityDomainUser = master['pki_security_domain_user']
-        data.securityDomainPassword = master['pki_security_domain_password']
+        data.securityDomainUri = self.master_dict['pki_security_domain_uri']
+        data.securityDomainUser = self.master_dict['pki_security_domain_user']
+        data.securityDomainPassword = self.master_dict['pki_security_domain_password']
 
     def set_new_security_domain(self, data):
         data.securityDomainType = "newdomain"
-        data.securityDomainName = master['pki_security_domain_name']
+        data.securityDomainName = self.master_dict['pki_security_domain_name']
 
     def set_database_parameters(self, data):
-        data.dsHost = master['pki_ds_hostname']
-        data.dsPort = master['pki_ds_ldap_port']
-        data.baseDN = master['pki_ds_base_dn']
-        data.bindDN = master['pki_ds_bind_dn']
-        data.database = master['pki_ds_database']
-        data.bindpwd = master['pki_ds_password']
-        if config.str2bool(master['pki_ds_remove_data']):
+        data.dsHost = self.master_dict['pki_ds_hostname']
+        data.dsPort = self.master_dict['pki_ds_ldap_port']
+        data.baseDN = self.master_dict['pki_ds_base_dn']
+        data.bindDN = self.master_dict['pki_ds_bind_dn']
+        data.database = self.master_dict['pki_ds_database']
+        data.bindpwd = self.master_dict['pki_ds_password']
+        if config.str2bool(self.master_dict['pki_ds_remove_data']):
             data.removeData = "true"
         else:
             data.removeData = "false"
-        if config.str2bool(master['pki_ds_secure_connection']):
+        if config.str2bool(self.master_dict['pki_ds_secure_connection']):
             data.secureConn = "true"
         else:
             data.secureConn = "false"
 
     def set_backup_parameters(self, data):
-        if config.str2bool(master['pki_backup_keys']):
+        if config.str2bool(self.master_dict['pki_backup_keys']):
             data.backupKeys = "true"
-            data.backupFile = master['pki_backup_keys_p12']
-            data.backupPassword = master['pki_backup_password']
+            data.backupFile = self.master_dict['pki_backup_keys_p12']
+            data.backupPassword = self.master_dict['pki_backup_password']
         else:
             data.backupKeys = "false"
 
     def set_admin_parameters(self, data):
-        data.adminEmail = master['pki_admin_email']
-        data.adminName = master['pki_admin_name']
-        data.adminPassword = master['pki_admin_password']
-        data.adminProfileID = master['pki_admin_profile_id']
-        data.adminUID = master['pki_admin_uid']
-        data.adminSubjectDN = master['pki_admin_subject_dn']
-        if config.str2bool(master['pki_import_admin_cert']):
+        data.adminEmail = self.master_dict['pki_admin_email']
+        data.adminName = self.master_dict['pki_admin_name']
+        data.adminPassword = self.master_dict['pki_admin_password']
+        data.adminProfileID = self.master_dict['pki_admin_profile_id']
+        data.adminUID = self.master_dict['pki_admin_uid']
+        data.adminSubjectDN = self.master_dict['pki_admin_subject_dn']
+        if config.str2bool(self.master_dict['pki_import_admin_cert']):
             data.importAdminCert = "true"
             # read config from file
-            with open(master['pki_admin_cert_file']) as f:
+            with open(self.master_dict['pki_admin_cert_file']) as f:
                 b64 = f.read().replace('\n', '')
             data.adminCert = b64
         else:
             data.importAdminCert = "false"
-            data.adminSubjectDN = master['pki_admin_subject_dn']
-            if master['pki_admin_cert_request_type'] == "pkcs10":
+            data.adminSubjectDN = self.master_dict['pki_admin_subject_dn']
+            if self.master_dict['pki_admin_cert_request_type'] == "pkcs10":
                 data.adminCertRequestType = "pkcs10"
 
                 noise_file = os.path.join(
-                    master['pki_client_database_dir'], "noise")
+                    self.master_dict['pki_client_database_dir'], "noise")
 
                 output_file = os.path.join(
-                    master['pki_client_database_dir'], "admin_pkcs10.bin")
+                    self.master_dict['pki_client_database_dir'], "admin_pkcs10.bin")
 
-                file.generate_noise_file(
-                    noise_file, int(master['pki_admin_keysize']))
+                self.deployer.file.generate_noise_file(
+                    noise_file, int(self.master_dict['pki_admin_keysize']))
 
-                certutil.generate_certificate_request(
-                                     master['pki_admin_subject_dn'],
-                                     master['pki_admin_keysize'],
-                                     master['pki_client_password_conf'],
+                self.deployer.certutil.generate_certificate_request(
+                                     self.master_dict['pki_admin_subject_dn'],
+                                     self.master_dict['pki_admin_keysize'],
+                                     self.master_dict['pki_client_password_conf'],
                                      noise_file,
                                      output_file,
-                                     master['pki_client_database_dir'],
+                                     self.master_dict['pki_client_database_dir'],
                                      None, None, True)
 
                 # convert output to ascii
@@ -3394,58 +3465,68 @@ class config_client:
                 raise Exception(log.PKI_CONFIG_PKCS10_SUPPORT_ONLY)
 
     def set_issuing_ca_parameters(self, data):
-        if master['pki_subsystem'] != "CA" or\
-           config.str2bool(master['pki_clone']) or\
-           config.str2bool(master['pki_subordinate']) or\
-           config.str2bool(master['pki_external']):
+        if self.master_dict['pki_subsystem'] != "CA" or\
+           config.str2bool(self.master_dict['pki_clone']) or\
+           config.str2bool(self.master_dict['pki_subordinate']) or\
+           config.str2bool(self.master_dict['pki_external']):
             # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
             # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone,
             # Subordinate CA, or External CA
-            data.issuingCA = master['pki_issuing_ca']
-            if master['pki_subsystem'] == "CA"  and\
-               config.str2bool(master['pki_external_step_two']):
+            data.issuingCA = self.master_dict['pki_issuing_ca']
+            if self.master_dict['pki_subsystem'] == "CA"  and\
+               config.str2bool(self.master_dict['pki_external_step_two']):
                 # External CA Step 2
                 data.stepTwo = "true";
 
     def create_system_cert(self, tag):
         cert = pki.system.SystemCertData()
-        cert.tag = master["pki_%s_tag" % tag]
-        cert.keyAlgorithm = master["pki_%s_key_algorithm" % tag]
-        cert.keySize = master["pki_%s_key_size" % tag]
-        cert.keyType = master["pki_%s_key_type" % tag]
-        cert.nickname = master["pki_%s_nickname" % tag]
-        cert.subjectDN = master["pki_%s_subject_dn" % tag]
-        cert.token = master["pki_%s_token" % tag]
+        cert.tag = self.master_dict["pki_%s_tag" % tag]
+        cert.keyAlgorithm = self.master_dict["pki_%s_key_algorithm" % tag]
+        cert.keySize = self.master_dict["pki_%s_key_size" % tag]
+        cert.keyType = self.master_dict["pki_%s_key_type" % tag]
+        cert.nickname = self.master_dict["pki_%s_nickname" % tag]
+        cert.subjectDN = self.master_dict["pki_%s_subject_dn" % tag]
+        cert.token = self.master_dict["pki_%s_token" % tag]
         return cert
 
     def retrieve_existing_server_cert(self, cfg_file):
         cs_cfg = PKIConfigParser.read_simple_configuration_file(cfg_file)
         cstype = cs_cfg.get('cs.type').lower()
         cert = pki.system.SystemCertData()
-        cert.tag = master["pki_ssl_server_tag"]
-        cert.keyAlgorithm = master["pki_ssl_server_key_algorithm"]
-        cert.keySize = master["pki_ssl_server_key_size"]
-        cert.keyType = master["pki_ssl_server_key_type"]
+        cert.tag = self.master_dict["pki_ssl_server_tag"]
+        cert.keyAlgorithm = self.master_dict["pki_ssl_server_key_algorithm"]
+        cert.keySize = self.master_dict["pki_ssl_server_key_size"]
+        cert.keyType = self.master_dict["pki_ssl_server_key_type"]
         cert.nickname = cs_cfg.get(cstype + ".sslserver.nickname")
         cert.cert = cs_cfg.get(cstype + ".sslserver.cert")
         cert.request = cs_cfg.get(cstype + ".sslserver.certreq")
-        cert.subjectDN = master["pki_ssl_server_subject_dn"]
+        cert.subjectDN = self.master_dict["pki_ssl_server_subject_dn"]
         cert.token = cs_cfg.get(cstype + ".sslserver.tokenname")
         return cert
+    
+class PKIDeployer:
+    """Holds the global dictionaries and the utility objects"""
+    
+    def __init__(self, pki_master_dict, pki_slots_dict = None):
+        # Global dictionary variables
+        self.master_dict = pki_master_dict
+        self.slots = pki_slots_dict
+        
+        # Utility objects
+        self.identity = _Identity(pki_master_dict)
+        self.namespace = _Namespace(pki_master_dict)
+        self.configuration_file = _ConfigurationFile(pki_master_dict)
+        self.instance = _Instance(pki_master_dict)
+        self.directory = _Directory(pki_master_dict, self.identity)
+        self.file = _File(pki_master_dict, pki_slots_dict, self.identity)
+        self.symlink = _Symlink(pki_master_dict, self.identity)
+        self.war = _War(pki_master_dict)
+        self.password = _Password(pki_master_dict)
+        self.certutil = _certutil(pki_master_dict)
+        self.pk12util = _pk12util(pki_master_dict)
+        self.kra_connector = _KRAConnector(pki_master_dict, self.password)
+        self.security_domain = _SecurityDomain(pki_master_dict, self.password)
+        self.systemd = _Systemd(pki_master_dict)
+        self.config_client = _ConfigClient(self)
+    
 
-# PKI Deployment Helper Class Instances
-identity = identity()
-namespace = namespace()
-configuration_file = configuration_file()
-# xml_file = xml_file()
-instance = instance()
-directory = directory()
-file = file()
-symlink = symlink()
-war = war()
-password = password()
-certutil = certutil()
-pk12util = pk12util()
-security_domain = security_domain()
-kra_connector = kra_connector()
-systemd = systemd()
